---
title: 'Creation of classifiers (pamr, SVM, random forest) with glioblastoma data (Gene Influences)'
output: html_document
date: "2023-08-30"
author : Marion Estoup
---


# Load/install libraries
```{r message=FALSE, warning=FALSE, results='hide'}
library(caret) # For confusion matrix
library(ComplexHeatmap) # For heatmap
library(pamr) # Classification
library(interp) # Plot mtry according to nodesize 
library(htmlwidgets) # Save plot
library(scales) # Palette colors
library(dplyr) # Data management/manipulation
library(stringr) # Data management/manipulation
library(stringi) # Data management/manipulation
library(tibble) # Data management/manipulation
library(Biobase) # Expressionset data/object
library(writexl) # Save files
library(knitr) # Show tables with rmarkdown
library(tidyverse) # Data manipulation
library(e1071) # SVM
library(readxl) # read data
```



# Data Management
```{r message=FALSE, warning=FALSE, results='hide'}
################################# DATA MANAGEMENT/MANIPULATION 


############### STEP THAT NEEDS TO BE ADAPTED ACCORDING TO DATA AND PATH

############### TRAIN DATA 

# Set seed for reproductibility
set.seed(1234)

# Set path
setwd("C:/Users/mario/Desktop/Data/")


# Load data
load("inf_gbm_with_cls.Rdata")

# PAMR needs a matrix (gene expression/influence) with samples in columns and gene names in rownames and it needs a dataframe with samples in rownames and one column classes/outcomes (it's done later in the code based on expressionset_data)

# Random Forest SRC needs a matrix (gene expression/influence) with gene names in columns and samples in rownames. In this matrix, we also need to have a column classes/outcomes in addition of the gene names. It also needs a dataframe with samples in rownames and one column classes/outcomes. (it's done later in the code based on expressionset_data)

# Create dataframe with classes and samples 
classes_samples <- data.frame(inf_gbm_with_cls[,"classf_1"])

# Rename column
names(classes_samples)[names(classes_samples) == "inf_gbm_with_cls....classf_1.."] <- "classes"

# Check data structure
#str(classes_samples)

# If classes/outcomes aren't factor you have to convert them with the following
classes_samples$classes <- as.factor(classes_samples$classes)

# Create matrix with gene names in rownames and samples in columns (for PAMR)

# Create matrix and remove classes/outcomes column
data_pamr <- inf_gbm_with_cls[,-c(1,2)]
# Transpose matrix
data_pamr <- t(data_pamr)
# Replace hyphens - by _ in rownames (gene names) in order to avoid issues 
rownames(data_pamr) <- gsub("-", "_", rownames(data_pamr))

```



```{r echo=T}
# Have a look at the data
kable(head(data_pamr))
```


```{r echo=T}
# Have a look at phenotype data (classes/outcomes and samples)
kable(head(classes_samples))
```





# Step 1 : Cancer Classification with PAMR Classifier

## Prepare Data for PAMR Classifier (60% for training and 40% for testing)
```{r message=FALSE, warning=FALSE,results='hide'}

########################################## STEP THAT CAN BE ADAPTED 

## Prepare data
# To perform classification, we need to have test and train data
# Thus, we split the data
# 60% as training data and 40% as testing data
n <- ncol(data_pamr) # columns (samples) 
training_samples <- sample(1:n,size = n*0.6)
train <- data_pamr[1:539,training_samples] # We take 539 genes (the total)
test <- data_pamr[1:539,-training_samples] # We take the rest

# To be sure there are no shared samples between the training and testing data
#sum(colnames(test) %in% colnames(train)) == 0
# TRUE so no shared samples between training and testing data
```


The surrogate variable analysis functions have been developed for population level analyses such as differential expression analysis in microarrays. In some cases, the goal of an analysis is prediction. In this case, data sets are generally composed a training set and a test set. For each sample in the training set, the outcome/class is known, but latent sources of variability are unknown. For the samples in the test set, neither the outcome/class or the latent sources of variability are known. “Frozen” surrogate variable analysis can be used to remove latent variation in the test data set. 

```{r message=FALSE, warning=FALSE}

########################################## STEP THAT CAN BE ADAPTED 



# Create phenotype data (classes/outcomes and samples) corresponding to train and test datasets
## For train data
train_pamr_pheno <- subset(classes_samples, rownames(classes_samples) %in% colnames(train))
# Put same order of samples between the two objects
train_pamr_pheno <- train_pamr_pheno[colnames(train), , drop = FALSE]
# Check if order is the same
#identical(colnames(train),rownames(train_pamr_pheno)) # TRUE

## For test data
test_pamr_pheno <- subset(classes_samples, rownames(classes_samples) %in% colnames(test))
# Put same order of samples between the two objects
test_pamr_pheno <- test_pamr_pheno[colnames(test), , drop = FALSE]
# Check if order is the same
#identical(colnames(test),rownames(test_pamr_pheno)) # TRUE
```




## Create PAMR Classifier
```{r message=FALSE, warning=FALSE, results='hide'}
# Prepare data for pamr classifier
data_pamr_classifier = list(x=train,y=train_pamr_pheno$classes, geneid=rownames(train),
                            samplelabels=rownames(train_pamr_pheno),
                            genenames=rownames(train))


# Train pamr classifier
pamr_classifier <- pamr.train(data=data_pamr_classifier)



## Train PAMR Classifier using cross validation and 5 folds
pamr_classifier_cv <- pamr.cv(fit=pamr_classifier, data=data_pamr_classifier, nfold=5)


# Retrieve the correct object in pamr_classifier_cv to make predictions on test data
pamr_classifier_cv2 <- pamr_classifier_cv[["cv.objects"]][[5]]

# This step to train PAMR Classifier with cross validation was repeated 5 times because we can't use the same function for the three classifiers we are using (PAMR, RF, SVM)
# So to make the results comparable we train each classifier 5 times using 5 folds
```


## Use PAMR Classifier for predictions on Test Data
```{r echo=T, message=FALSE, warning=FALSE}
# Predict classes/outcomes/labels for test data with PAMR Classifier (done with cross validation)
pamr_cv_predictions <- pamr.predict(fit=pamr_classifier_cv2, newx=test, threshold=1)
#pamr_cv_predictions

# Show predictions in a table
#table(pamr_cv_predictions,test_pamr_pheno$classes)


# First time
# pamr_cv_predictions   1   2   3   4   5   6   7
                  #1 150   6   0   1   2   2   1
                  #2   7  95   5  10   0   0   0
                  #3   1   6  99   4   0   3   2
                  #4   5   7   1  69   2   1   2
                  #5   0   0   0   5  60   2   2
                  #6   4   3   1   1   1  46   0
                  #7   0   0   4   0   3   4  28
                  
                  


# Second time 
# pamr_cv_predictions   1   2   3   4   5   6   7
                  #1 150   6   0   2   2   2   1
                  #2   7  95   5  10   0   0   0
                  #3   1   6  99   4   0   3   2
                  #4   5   6   1  69   3   4   1
                  #5   0   0   0   4  59   2   2
                  #6   4   4   1   1   1  43   0
                  #7   0   0   4   0   3   4  29
                  



# Third time 
# pamr_cv_predictions   1   2   3   4   5   6   7
                  #1 150   6   0   2   2   2   1
                  #2   7  95   5  10   0   0   0
                  #3   1   7 100   4   0   3   2
                  #4   5   6   1  68   2   3   1
                  #5   0   0   0   5  60   2   2
                  #6   4   3   1   1   1  44   0
                  #7   0   0   3   0   3   4  29
                  
                  


# Fourth time 
# pamr_cv_predictions   1   2   3   4   5   6   7
                  #1 150   4   0   2   2   2   2
                  #2   7  99   5  10   0   0   0
                  #3   1   6  99   4   0   3   2
                  #4   5   5   1  71   2   2   2
                  #5   0   0   0   2  61   2   2
                  #6   4   3   1   1   1  44   0
                  #7   0   0   4   0   2   5  27
                  
                  
  

# Fifth time 
# pamr_cv_predictions   1   2   3   4   5   6   7
                  #1 150   5   0   2   3   1   2
                  #2   7  96   5  10   0   1   0
                  #3   1   6  99   4   0   3   2
                  #4   5   7   1  69   3   3   2
                  #5   0   0   0   4  58   2   2
                  #6   4   3   0   1   1  42   0
                  #7   0   0   5   0   3   6  27
                  
                  
```


## Retrieve Confusion Matrix and calculate several metrics about the PAMR Classifier performance
```{r echo=T, message=FALSE, warning=FALSE}

# We can show the confusion matrix with the following code
#pamr.confusion(pamr_classifier_cv,threshold=1)



# Or we can show the confusion matrix with several metrics thanks to confusionMatrix function
# Create dataframe with PAMR predictions
pamr_cv_predictions_df <- data.frame(pamr_cv_predictions)

# Create rownames in dataframe thanks to rownames in test data (samples)
rownames(pamr_cv_predictions_df) <- rownames(test_pamr_pheno)

# Create Reference column in dataframe to have the classes/outcomes
pamr_cv_predictions_df["Reference"] <- test_pamr_pheno[,"classes"]

# Rename first column in dataframe 
colnames(pamr_cv_predictions_df)[1] <- "Predictions"



# Create confusion matrix on test data
confusion_matrix_pamr <- confusionMatrix(data = pamr_cv_predictions_df[,"Predictions"],
                                         reference = pamr_cv_predictions_df[,"Reference"],
                                         mode = "everything")

# Show Confusion matrix on test data using PAMR classifier
#confusion_matrix_pamr
```


## Calculate Variable Importance by class
```{r message=FALSE, warning=FALSE, results='hide'}

####################### STEP THAT CAN BE ADAPTED (TRESHOLD AND SAVE FILE)

# List the significant genes (top-k genes or variable importance)
pamr_top_genes <- data.frame(pamr.listgenes(pamr_classifier, data_pamr_classifier, threshold=1))

# Rename columns
colnames(pamr_top_genes) <- c("Gene_names", "Vimp_class_1","Vimp_class_2",
                              "Vimp_class_3","Vimp_class_4", "Vimp_class_5",
                              "Vimp_class_6", "Vimp_class_7")

# If you want to save file you can do the following :
write_xlsx(pamr_top_genes,"Vimp_pamr_influences.xlsx")
```


# Select Top K Variables (Genes)
```{r echo=TRUE}

############### STEP THAT NEEDS TO BE ADAPTED ACCORDING TO THE NUMBER OF CLASSES/OUTCOMES


# Reorder the data frame based on non-zero values in columns (classes)
# The idea is to have the 0 values at the bottom and values different than 0 at the top of the df/matrix to select the first top-k genes to represent in the heatmap afterwards
non_zero_rows <- pamr_top_genes[rowSums(pamr_top_genes[, 2:8] != 0) > 0, ]
zero_rows <- pamr_top_genes[rowSums(pamr_top_genes[, 2:8] == 0) == 4, ]

# Store the previous results in one object
pamr_top_genes <- rbind(non_zero_rows, zero_rows)

# Convert data frame to matrix 
pamr_top_genes <- as.matrix(pamr_top_genes)

# Collect gene expression/influence values corresponding to our top genes obtained with PAMR
topk_genes_pamr <- data_pamr[pamr_top_genes[,"Gene_names"],]

# Select the first top 50 genes in our list
topk_genes_pamr <- topk_genes_pamr[c(1:50),]
```



```{r echo=TRUE}
# Scale data before heatmap
topk_genes_pamr <- scale(topk_genes_pamr, center = TRUE, scale = TRUE)
```



## Heatmap with top k genes obtained with PAMR
```{r error=TRUE, message=FALSE, warning=FALSE}

############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 


### Heatmap Top genes PAMR


# Create object ann to store classes/outcomes
ann <- classes_samples


# Assign a color for each different class thanks to a palette of colors hue_pal
palette_colors <- hue_pal()(length(unique(ann$classes)))%>%
  rlang::set_names(unique(ann$classes))

#  1         3         2         5         4         7         6 
# "#F8766D" "#C49A00" "#53B400" "#00C094" "#00B6EB" "#A58AFF" "#FB61D7" 


# Now that we have the specific color for each class we can create a column
# colors in ann df to have the corresponding color in front of each class/row
ann <- 
  ann%>%
  mutate(colours = 
           case_when(.$classes %in% "1" ~ "#F8766D",
                     .$classes %in% "2" ~ "#53B400",
                     .$classes %in% "3" ~ "#C49A00",
                     .$classes %in% "4" ~ "#00B6EB",
                     .$classes %in% "5" ~ "#00C094",
                     .$classes %in% "6" ~ "#FB61D7",
                     .$classes %in% "7" ~ "#A58AFF")
  )


# Order class/outcome in ann df (all samples that belong to class 1, then all samples that belong to class 2, then all samples that belong to class 3, etc)
ann <- arrange(ann,classes)



# Now that we have the column with all colours corresponding to each class we can retrieve
# this column and store it in a vector
colours_vector <- ann$colours
#colours_vector

# And we can assign the classes in front of each color in this vector
names(colours_vector) <- ann$classes
#colours_vector

# Now we can remove the column colours in ann df because we don't need it
# We have the info in colours_vector
ann$colours = NULL


# Order columns in matrix to have the same order as the new rownames order in ann df
topk_genes_pamr <- topk_genes_pamr[ , rownames(ann)]


# Create colAnn that contains classes/outcomes and corresponding colours to give to the  heatmap function after
colAnn <- HeatmapAnnotation(df = ann, # data
                            which = 'col',
                            col = list(classes=colours_vector), # colour list
                            show_annotation_name = FALSE, # remove annotation name
                            annotation_legend_param = list(title="Classes")
)




# Open png instance if you want to save heatmap
png(file="heatmap_pamr_influences.png")

# Create Matrix of the top k genes for all classes
heatmap_pamr <- Heatmap(topk_genes_pamr, 
                        name = "Genes inf", #title of legend
                        column_title = "Top k genes with PAMR
                        Samples", # title of columns
                        row_title = "Genes", # title of rows
                        column_names_gp = gpar(fontsize = 5), # text size
                        row_names_gp = gpar(fontsize = 5), # text size
                        show_column_dend = FALSE, # don"t show dendrogram for cols
                        cluster_columns = FALSE, # don't cluster otherwise classes are shuffled and it's not ordered
                        column_dend_reorder = FALSE, # same as cluster_columns
                        top_annotation = colAnn, # give the colors for classes
                        show_column_names = FALSE,# don't show column names (not readable because lot of samples/columns)
) 


# Draw matrix
draw(heatmap_pamr)
# Stop graph device
dev.off()
```


```{r echo=TRUE}
# Draw heatmap with top k genes obtained with PAMR Classifier
draw(heatmap_pamr)
```



## Conclusion PAMR

We had data as a matrix with genes in rownames and samples in columns. This data contained the gene influences of the most differentially expressed genes because Limma package was used before, which gave this inftum data. We had to change hyphens in gene names (- by _) to avoid issues.

We can't use ExpressionSet object directly with PAMR library. Thus, we have a matrix with genes in rownames and samples in columns that contain gene influences values. We have a dataframe (classes_samples) with samples in rownames and one column containing the real classes/outcomes of those samples. Samples look like the following : GSM1185877, etc. There are 7 different classes stored in classes column (dataframe classes_samples) : 1, 2, 3, 4, 5, 6, 7. 


We created a PAMR Classifier with cross validation and we predicated classes/outcomes/labels with test data (inftum GBM : gene influences). We calculated variable importance and we ploted the most significative genes with a heatmap.


For more information :
  
http://compdiag.molgen.mpg.de/ngfn/docs/2004/nov/exercises-classification.pdf

https://rdrr.io/bioc/sva/f/inst/doc/sva.pdf

https://tibshirani.su.domains/PAM/Rdist/doc/readme.html

https://cran.r-project.org/web/packages/pamr/pamr.pdf

https://www.quantargo.com/help/r/latest/packages/pamr/1.56.1/pamr.cv








# Step 2 : Cancer Classification with SVM (Support Vector Machines)


## Prepare data for SVM
```{r echo=TRUE}
# Create data for SVM
train_svm <- cbind.data.frame(train_pamr_pheno$classes,t(train))
# Rename column
colnames(train_svm)[1] <- "Classes"

test_svm <- cbind.data.frame(test_pamr_pheno$classes,t(test))
# Rename column
colnames(test_svm)[1] <- "Classes"
```




## Create SVM Classifier and use it to predict classes/outcomes/labels
```{r echo=TRUE}

# Train SVM Classifier using cross validation with 5 folds (repeated 5 times like the PAMR Classifier)
SVM_Classifier_cv <- train(Classes ~ ., data = train_svm,
                           method = "svmRadial",
                           trControl = trainControl(method = "cv", number = 5))


# Use SVM Classifier to predict classes
SVM_Classifier_cv_predictions <- predict(SVM_Classifier_cv,
                                         newdata = test_svm[,-1], # Test data without classes
                                         decision.value=TRUE)
```


```{r echo=TRUE}
# Create confusion matrix metrics
confusion_matrix_svm <- confusionMatrix(SVM_Classifier_cv_predictions, reference=test_pamr_pheno$classes)

# Show confusion matrix table (first time so train+ predict)
#confusion_matrix_svm$table


# First time
#             Reference
#Prediction   1   2   3   4   5   6   7
 #        1 158   8   1   4   1   8   2
  #       2   5 102   6   8   0   0   0
   #      3   0   3 100   3   2   4   3
    #     4   2   1   3  73   4   3   3
     #    5   0   0   0   1  58   1   0
      #   6   1   3   0   1   1  41   0
       #  7   1   0   0   0   2   1  27
         


# Show confusion matrix table (second time)
#              Reference
# Prediction   1   2   3   4   5   6   7
  #       1 158   8   1   4   1   8   2
   #      2   5 102   6   8   0   0   0
    #     3   0   3 100   3   2   4   3
     #    4   2   1   3  73   4   3   3
      #   5   0   0   0   1  58   1   0
       #  6   1   3   0   1   1  41   0
        # 7   1   0   0   0   2   1  27
         

# Show confusion matrix table (third time)
# Reference
# Prediction   1   2   3   4   5   6   7
  #       1 157   8   1   4   1   8   2
   #      2   6 102   6   8   0   0   0
    #     3   0   3 100   3   2   4   3
     #    4   2   1   3  73   4   3   3
      #   5   0   0   0   1  58   1   0
       #  6   1   3   0   1   1  41   0
        # 7   1   0   0   0   2   1  27
         




# Show confusion matrix table (fourth time)
#            Reference
#Prediction   1   2   3   4   5   6   7
      #   1 158   8   1   4   1   8   2
       #  2   5 102   6   8   0   0   0
        # 3   0   3 100   3   2   4   3
         #4   2   1   3  73   4   3   3
         #5   0   0   0   1  58   1   0
         #6   1   3   0   1   1  41   0
         #7   1   0   0   0   2   1  27
         


# Show confusion matrix table (fifth time)
#             Reference
#Prediction   1   2   3   4   5   6   7
 #        1 158   8   1   4   1   8   2
  #       2   5 102   6   8   0   0   0
   #      3   0   3 100   3   2   4   3
    #     4   2   1   3  73   4   3   3
     #    5   0   0   0   1  58   1   0
      #   6   1   3   0   1   1  41   0
       #  7   1   0   0   0   2   1  27
         

```



## Conclusion SVM 

SVM is a black box classifier. Therefore we can't calculate variable importance like we did with PAMR. Thus, we can't get top k genes and a heatmap, but we can compare the classifiers performances.









# Step 3 : Cancer Classification with Random Forest

## Create Random Forest Classifier and calculate Variable Importance by class
```{r eval=FALSE, include=TRUE}


################################# STEP THAT CAN BE ADAPATED (DEPENDS IF YOU WANT VARIABLE IMPORTANCE BY CLASS AND ADAPT SEVERAL ARGUMENTS IN FUNCTIONS)

# Create RF Classifier with importance variable and 5 folds for cross validation
RF_Classifier_cv <- train(Classes ~ ., data = train_svm,
                          method = "rf", # random forest algorithm
                          trControl = trainControl(method = "cv", number = 5),
                          metric = "Accuracy", importance = TRUE
)

# Calculate importance variable (genes)
importance_rf <- varImp(RF_Classifier_cv)

# Create dataframe
importance_rf <- importance_rf[["importance"]]

# Add rownames in column
importance_rf$Gene_names <- rownames(importance_rf)

# Order columns of dataframe
importance_rf <- importance_rf[,c(8,1,2,3, 4, 5, 6, 7)]


# Rename columns
colnames(importance_rf) <- c("Gene_names", "Vimp_class_1","Vimp_class_2",
                            "Vimp_class_3","Vimp_class_4", "Vimp_class_5",
                            "Vimp_class_6", "Vimp_class_7")

# If you want to save file you can do the following :
write_xlsx(importance_rf,"Vimp_RF_influences.xlsx")
```




## Create Random Forest Classifier and use it to predict outcomes/classes/labels
```{r echo=TRUE}

########################### CREATE RF CLASSIFIER AND PREDICT OUTCOMES 


# Create RF Classifier using cross validation and 5 folds (repeated 6 times like PAMR and SVM)
RF_Classifier_cv <- train(Classes ~ ., data = train_svm,
  method = "rf", # random forest algorithm
  trControl = trainControl(method = "cv", number = 5),
  metric = "Accuracy"
)

# It took me around 8.40 minutes to train this classifier with my session
```


```{r echo=TRUE}
# Use RF Classifier to predict classes on test data (less the first column because it's the classes/outcomes/Labels)
RF_Classifier_cv_predictions <- predict(RF_Classifier_cv, newdata = test_svm[,-1])

# Create confusion matrix 
confusion_matrix_rf <- confusionMatrix(RF_Classifier_cv_predictions, reference = test_pamr_pheno$classes)



# Show confusion matrix table (first time so train + predict)
#confusion_matrix_rf$table


# First time
#            Reference
#Prediction   1   2   3   4   5   6   7
 #        1 158   9   1   9   3  11   3
  #       2   5  94   6  13   0   1   0
   #      3   0   7  99   6   1   7   4
    #     4   2   4   1  60   8   4   5
     #    5   0   0   0   2  54   1   1
      #   6   2   3   2   0   1  34   0
       #  7   0   0   1   0   1   0  22
         

# Show confusion matrix table (second time)
#            Reference
#Prediction   1   2   3   4   5   6   7
 #        1 155   9   1   8   3  11   3
  #       2   7  95   7  12   0   1   0
   #      3   0   7  97   6   1   7   4
    #     4   2   3   1  62   9   4   6
     #    5   0   0   1   2  54   1   0
      #   6   3   3   2   0   0  34   0
       #  7   0   0   1   0   1   0  22
         

# Show confusion matrix table (third time)
# Reference
# Prediction   1   2   3   4   5   6   7
  #       1 155   9   2   7   2  11   3
   #      2   7  93   7  13   0   2   0
    #     3   0   8  96   6   1   6   4
     #    4   3   5   1  63   8   5   3
      #   5   0   0   1   1  55   1   2
       #  6   2   2   2   0   1  33   1
        # 7   0   0   1   0   1   0  22
         


# Show confusion matrix table (fourth time)
# Reference
# Prediction   1   2   3   4   5   6   7
  #       1 155   9   1   6   3  11   2
   #      2   6  97   7  14   0   2   0
    #     3   1   5  97   5   1   7   4
     #    4   3   4   1  64   9   4   4
      #   5   0   0   1   1  54   1   1
       #  6   2   2   2   0   1  33   0
        # 7   0   0   1   0   0   0  24
         




# Show confusion matrix table (fifth time)
#           Reference
#Prediction   1   2   3   4   5   6   7
 #        1 157   9   1   6   3  10   2
  #       2   6  95   7  16   0   1   0
   #      3   0   6  97   4   1   7   4
    #     4   1   3   1  62   7   4   5
     #    5   0   0   1   2  55   2   1
      #   6   3   4   2   0   1  34   0
       #  7   0   0   1   0   1   0  23
         



```









# Select Top K Variables (Genes)
```{r echo=TRUE, message=FALSE, warning=FALSE}


#################################### STEP THAT CAN BE ADAPTED (number of top genes, number of classes, ...)


# Get importance measures of genes
importance_rf <- varImp(RF_Classifier_cv)

# Order by descending order and select k top genes
topk_genes_rf <- importance_rf$importance %>% arrange(desc(Overall)) %>% top_n(n = 50)


# Retrieve influences or expressions values corresponding to those top genes
data_rf <- t(data_pamr)
data_rf <- cbind(data_rf, classes_samples$classes)
colnames(data_rf)[ncol(data_rf)] <- "Classes"
topk_genes_rf <- data_rf[, c("Classes", rownames(topk_genes_rf))]

# Scale data before heatmap
topk_genes_rf <- scale(topk_genes_rf[,-1], center = TRUE, scale = TRUE)




############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 


### Heatmap Top genes RF


# Order rownames in matrix to have the same order as the new rownames order in ann df
topk_genes_rf <- topk_genes_rf[rownames(ann), ]
topk_genes_rf <- t(topk_genes_rf)



# Open png instance if you want to save heatmap
png(file="heatmap_RF_influences.png")

# Create Matrix of the top k genes for all classes
heatmap_rf <- Heatmap(topk_genes_rf, 
                        name = "Genes inf", #title of legend
                        column_title = "Top k genes with RF
                        Samples", # title of columns
                        row_title = "Genes", # title of rows
                        column_names_gp = gpar(fontsize = 5), # text size
                        row_names_gp = gpar(fontsize = 5), # text size
                        show_column_dend = FALSE, # don"t show dendrogram for cols
                        cluster_columns = FALSE, # don't cluster otherwise classes are shuffled and it's not ordered
                        column_dend_reorder = FALSE, # same as cluster_columns
                        top_annotation = colAnn, # give the colors for classes
                        show_column_names = FALSE,# don't show column names (not readable because lot of samples/columns)
) 


# Draw matrix
draw(heatmap_rf)
# Stop graph device
dev.off()
```


```{r echo=TRUE}
# Draw heatmap with top k genes obtained with RF Classifier
draw(heatmap_rf)
```





# Step 4 Compare Classifiers Performances
```{r echo=TRUE}

# Store top gene names for each library because for now they are matrices with samples, genes expression values etc, 

# pamr
filtered_genes_pamr <- rownames(topk_genes_pamr)

# random forest 
filtered_genes_rf <- rownames(topk_genes_rf)
```



```{r eval=FALSE, include=FALSE}
# Create dataframe with accuracy and kappa values for all libraries
# Add c() when using results from multiple libraries
# Store accuracy values for each library
Accuracy_pamr <- confusion_matrix_pamr[["overall"]][["Accuracy"]]
Accuracy_rf <- confusion_matrix_rf[["overall"]][["Accuracy"]]
Accuracy_svm <- confusion_matrix_svm[["overall"]][["Accuracy"]]
All_accuracy <- c(Accuracy_pamr, Accuracy_rf, Accuracy_svm)

# Store kappa values for each library
Kappa_pamr <- confusion_matrix_pamr[["overall"]][["Kappa"]]
Kappa_rf <- confusion_matrix_rf[["overall"]][["Kappa"]]
Kappa_svm <- confusion_matrix_svm[["overall"]][["Kappa"]]
All_kappa <- c(Kappa_pamr, Kappa_rf, Kappa_svm)

# Create dataframe with accuracy and kappa values that we have stored
df_all_confusion_matrices <- data.frame(All_accuracy, All_kappa)



# Rename rownames to have the libraries' names
rownames(df_all_confusion_matrices) <- c("PamR","Random_Forest", "SVM")
# Rename columns 
colnames(df_all_confusion_matrices) <- c("Accuracy", "Kappa")


```


## Metrics: Sensitivity, Specificity, Precision, ... for all classifiers
```{r echo=TRUE}
# Calculate metrics based on confusion matrix

# Create function to calculate various classification metrics including MCC from a confusion matrix
calculate_classification_metrics <- function(conf_matrix) {
  TP <- sum(diag(conf_matrix)) # True positive
  TN <- sum(conf_matrix) - sum(conf_matrix[row(conf_matrix) == col(conf_matrix)]) # True negative
  FP <- sum(conf_matrix[row(conf_matrix) != col(conf_matrix)]) # False positive
  FN <- sum(conf_matrix) - sum(conf_matrix[row(conf_matrix) == col(conf_matrix)]) # False negative
  
  # Sensitivity (Recall)
  sensitivity <- TP / (TP + FN)
  
  # Specificity
  specificity <- TN / (TN + FP)
  
  # Precision
  precision <- TP / (TP + FP)
  
  # F1 Score
  f1_score <- 2 * (precision * sensitivity) / (precision + sensitivity)
  
  # Balanced Accuracy
  balanced_accuracy <- (sensitivity + specificity) / 2
  
  # MCC calculation
  factor <- 1e6
  mcc <- (factor * TP * TN - factor * FP * FN) / sqrt((factor * TP + FP) * (factor * TP + FN) * (factor * TN + FP) * (factor * TN + FN))
  
  # Store results in data frame
  metrics <- data.frame(
    Sensitivity = sensitivity,
    Specificity = specificity,
    Precision = precision,
    Recall = sensitivity, # Recall is the same as Sensitivity
    F1_Score = f1_score,
    Balanced_Accuracy = balanced_accuracy,
    MCC = mcc
  )
  
  # Return data frame
  return(metrics)
}
```


```{r echo=TRUE}
# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_pamr$table

# Use function to calculate metrics
metrics <- calculate_classification_metrics(conf_matrix)

# Add metrics to dataframe
df_all_confusion_matrices <- data.frame(metrics)
```

```{r echo=TRUE}
# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_rf$table

# Use function to calculate metrics
metrics <- calculate_classification_metrics(conf_matrix)

# Add metrics to dataframe
df_all_confusion_matrices[2,] <- metrics
```

```{r echo=TRUE}
# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_svm$table

# Use function to calculate metrics
metrics <- calculate_classification_metrics(conf_matrix)

# Add metrics to dataframe
df_all_confusion_matrices[3,] <- metrics
```



```{r echo=TRUE}
# Add mean values of metrics to dataframe
df_all_confusion_matrices[1,8:15] <- average_metrics_pamr
df_all_confusion_matrices[2,8:15] <- average_metrics_rf
df_all_confusion_matrices[3,8:15] <- average_metrics_svm
# Order data frame
df_all_confusion_matrices <- df_all_confusion_matrices[,c(15,1,2,3,4,5,6,7,8,9,10,11,12,13,14)]

# If you want to save file you can do the following :
write_xlsx(df_all_confusion_matrices,"Classifiers_Performance.xlsx")
```



```{r echo=TRUE}
# Show dataframe
kable(df_all_confusion_matrices)
```







## Metrics : Specificity, Sensitivity, Precision,... for all classifiers by class
```{r echo=TRUE}

############### STEP THAT NEEDS TO BE ADAPTED ACCORDING TO CLASSES/OUTCOMES NAMES


# Create dataframe with sensitivity, specificity, etc for each class for all libraries
# Store those results for each library
Metrics_pamr <- confusion_matrix_pamr[["byClass"]]
Metrics_rf <- confusion_matrix_rf[["byClass"]]
Metrics_svm <- confusion_matrix_svm[["byClass"]]

# Concatenate all matrices into one
All_metrics <- rbind(Metrics_pamr, Metrics_rf, Metrics_svm)

# Rename rownames
rownames(All_metrics) <- c("Class_1_pamR",
                           "Class_2_pamR",
                           "Class_3_pamR",
                           "Class_4_pamR",
                           "Class_5_pamR",
                           "Class_6_pamR",
                           "Class_7_pamR",
                           
                           "Class_1_Random_Forest",
                           "Class_2_Random_Forest", 
                           "Class_3_Random_Forest", 
                           "Class_4_Random_Forest", 
                           "Class_5_Random_Forest", 
                           "Class_6_Random_Forest", 
                           "Class_7_Random_Forest",
                           
                           "Class_1_SVM",
                           "Class_2_SVM",
                           "Class_3_SVM",
                           "Class_4_SVM",
                           "Class_5_SVM",
                           "Class_6_SVM",
                           "Class_7_SVM")



# Create dataframe                          
All_metrics <- data.frame(All_metrics)

# Add column to dataframe
All_metrics$Classifiers <- rownames(All_metrics)

# Remove several columns
All_metrics <- All_metrics[,c(1,2,5,6,7, 11, 12)]

```



```{r echo=TRUE}

# Create function to calculate Matthew Coefficient Correlation By Class 
calculate_MCC <- function(conf_matrix) {
  num_classes <- nrow(conf_matrix) # Number of classes
  mcc_values <- numeric(num_classes) # Number of mcc values according to the number of classes
  
  for (i in 1:num_classes) { # For each class
    TP <- conf_matrix[i, i] # True positive
    FP <- sum(conf_matrix[i, ]) - TP # False positive
    FN <- sum(conf_matrix[, i]) - TP # False negative
    TN <- sum(diag(conf_matrix)) - (TP + FP + FN) # True negative
    
    factor <- 1e6  # Create factor to avoid NA values because if values are too high it creates NA values
    mcc_values[i] <- (factor * TP * TN - factor * FP * FN) / sqrt((factor * TP + FP) * (factor * TP + FN) * (factor * TN + FP) * (factor * TN + FN)) # Formula to calculate MCC
  }
  
  return(mcc_values) # Return values
}


### Calculate MCC by class for PAMR Classifier
# Use the created function to calculate MCC by class
total_mcc <- calculate_MCC(confusion_matrix_pamr$table)
# Put value in a vector that we'll add to the dataframe that contains accuracy and kappa for all classifiers afterwards
mcc_by_class <- c(total_mcc)


### Calculate MCC by class for Random Forest Classifier
# Use the created function to calculate MCC 
total_mcc <- calculate_MCC(confusion_matrix_rf$table)
# Add second value to the vector that we'll add to the dataframe that contains accuracy and kappa for all classifiers afterwards
mcc_by_class <- append(mcc_by_class, total_mcc)


### Calculate MCC by class for SVM Classifier
# Use the created function to calculate MCC 
total_mcc <- calculate_MCC(confusion_matrix_svm$table)
# Add second value to the vector that we'll add to the dataframe that contains accuracy and kappa for all classifiers afterwards
mcc_by_class <- append(mcc_by_class, total_mcc)

```




```{r echo=TRUE}
# Add MCC values by class to dataframe with metrics (sensitivity, specificity, ...) for all classifiers
All_metrics$MCC <- mcc_by_class

# Order column of dataframe
All_metrics <- All_metrics[,c(7,1,2,3, 4, 5, 6, 8)]

# Add mean values of metrics to dataframe
All_metrics[1:7,9:15] <- average_metrics_pamr_class[,1:7]
All_metrics[8:14,9:15] <- average_metrics_rf_class[,1:7]
All_metrics[15:21,9:15] <- average_metrics_svm_class[,1:7]


# If you want to save file you can do the following :
write_xlsx(All_metrics,"Classifiers_Performance_By_Class.xlsx")
```




```{r echo=TRUE}
# Show table with metrics
kable(All_metrics)
```





## Top genes for all classifiers 
```{r echo=TRUE}

# Store top genes names for all libraries
Vector_topgenes_Pamr <- rownames(topk_genes_pamr)
Vector_topgenes_Rf <- rownames(topk_genes_rf)

# Calculate max length of the previous vectors containing top genes names for all libraries
max_length <- max(length(Vector_topgenes_Pamr), length(Vector_topgenes_Rf))

#set length of each vector equal to max length
length(Vector_topgenes_Pamr) <- max_length
length(Vector_topgenes_Rf) <- max_length

# We did that because we have vectors of different lengths 
# If we do nothing the vector with less values will add the same values over and over again
# If we do that, the vector with less values will add na values instead of creating "fake" values


# Create dataframes with the previous vectors containing top gene symbols
df_top_genes_all <- data.frame(PamR = Vector_topgenes_Pamr,
                               
                               Random_Forest = Vector_topgenes_Rf)
```




```{r echo=TRUE}
# Order df_top_genes_all to align common genes between the libraries
df_top_genes_all2 <- df_top_genes_all

#Get matched indices between the columns
inds1 <- match(df_top_genes_all$PamR, df_top_genes_all$Random_Forest)

inds2 <- match(df_top_genes_all$Random_Forest, df_top_genes_all$PamR)


#Replace value in second column in the same order as the first column
df_top_genes_all2$Random_Forest <- df_top_genes_all$Random_Forest[inds1]
# Order by second column
df_top_genes_all2 <- df_top_genes_all2[order(df_top_genes_all2$Random_Forest), ]


#Replace NA in second column with unmatched value.
df_top_genes_all2$Random_Forest[is.na(df_top_genes_all2$Random_Forest)] <- df_top_genes_all$Random_Forest[is.na(inds2)]



# Display table
kable(df_top_genes_all2)

# If you want to save file you can do the following :
write_xlsx(df_top_genes_all2,"Top_genes.xlsx")
```


## Number of common genes between classifiers 
```{r echo=TRUE}
# Tab representing the number of common top genes between the four libraries

df_common_genes <- data.frame(Library = c("PamR", "Random_Forest"),
                              
                              PamR = c(
                                sum(filtered_genes_pamr %in% filtered_genes_pamr),
                                sum(filtered_genes_pamr %in% filtered_genes_rf)),
                              
                              
                              Random_Forest = c(
                                sum(filtered_genes_rf %in% filtered_genes_pamr),
                                sum(filtered_genes_rf %in% filtered_genes_rf)))

# Display table
knitr::kable(df_common_genes)
```





## Final Conclusion 

With the previous summary tabs, we can say that the classifier having the best accuracy is 
SVM (87%), followed by PAMR (84%), followed by Random Forest (81%).







# Session Information
```{r echo=TRUE}
sessionInfo()
```




# Additional Information 
```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# We can't use a common function for PAMR, RF and SVM classifiers to train them with cross validation
# Thus, to make the results comparable we trained each classifiers 5 times using 5-folds cross validation
# With the following code we calculated and stored all metrics (precision, sensibility, etc) and confusion matrix for each iteration 
# So if you want to use it you have to train and predict one classifier, then do all the following with the corresponding names/dataframes/confusion matrix. Therefore you'll have metrics_classifiername_1 and conf_matrix_class_classifiername_1

# metrics_classifiername_1 contains Sensibility, Specificity, Precision, Recall, F1, Balanced.accuracy and MCC for the classifier (total)

# conf_matrix_class_classifiername_1 contains Sensibility, Specificity, Precision, Recall, F1, Balanced.accuracy and MCC for the each classes


# Then you have to do a second iteration so run train and predict again for the classifier
# After you calculate and store all metrics and confusion matrix for the second iteration so you'll have metrics_classifiername_2 and conf_matrix_class_classifiername_2

# Etc (train + predict again and calculate, store metrics to have metrics_classifiername_3 and conf_matrix_class_classifiername_3 etc until the number of iteration that you want)

# Once all iterations are finished, you can calculate the mean metrics in total and by class with the last two pieces of code. It will give you average_metrics_classifiername and average_metrics_classifiername_class

# average_metrics_classifiername contains Mean_Sensitivity, Mean_Specificity, Mean_Precision, Mean_Recall, Mean_F1, Mean_Balanced.Accuracy, Mean_MCC
# So these are the means of all metrics values for the specific classifier (values that we had for the number of iteration that we did, 5 in our case) 

# average_metrics_classifiername_class contains Mean_Sensitivity, Mean_Specificity, Mean_Precision, Mean_Recall, Mean_F1, Mean_Balanced.Accuracy, Mean_MCC
# So these are the means of all metrics values for the specific classifier for each class (values that we had for the number of iteration that we did, 5 in our case) 


# After all those steps, if you have a second, third, ... classifier you can do the same : train and predict for a first time, then calculate metrics in total and by class
# Then do another iteration if you want, calculate metrics in total and by class
# Etc according to your number of iterations
# Finally, you can calculate means of those values according to the number of iterations you did to train and predict 


# !! If you do this with multiple classifiers you'll have to change/adapt the names of some variables (especially metrics and dataframe names) !!



# Calculate metrics based on confusion matrix

# Create function to calculate various classification metrics including MCC from a confusion matrix
calculate_classification_metrics <- function(conf_matrix) {
  TP <- sum(diag(conf_matrix)) # True positive
  TN <- sum(conf_matrix) - sum(conf_matrix[row(conf_matrix) == col(conf_matrix)]) # True negative
  FP <- sum(conf_matrix[row(conf_matrix) != col(conf_matrix)]) # False positive
  FN <- sum(conf_matrix) - sum(conf_matrix[row(conf_matrix) == col(conf_matrix)]) # False negative
  
  # Sensitivity (Recall)
  sensitivity <- TP / (TP + FN)
  
  # Specificity
  specificity <- TN / (TN + FP)
  
  # Precision
  precision <- TP / (TP + FP)
  
  # F1 Score
  f1_score <- 2 * (precision * sensitivity) / (precision + sensitivity)
  
  # Balanced Accuracy
  balanced_accuracy <- (sensitivity + specificity) / 2
  
  # MCC calculation
  factor <- 1e6
  mcc <- (factor * TP * TN - factor * FP * FN) / sqrt((factor * TP + FP) * (factor * TP + FN) * (factor * TN + FP) * (factor * TN + FN))
  
  # Store results in data frame
  metrics <- data.frame(
    Sensitivity = sensitivity,
    Specificity = specificity,
    Precision = precision,
    Recall = sensitivity, # Recall is the same as Sensitivity
    F1_Score = f1_score,
    Balanced_Accuracy = balanced_accuracy,
    MCC = mcc
  )
  
  # Return data frame
  return(metrics)
}
```



```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# First time 

# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_rf$table
# Use function
metrics_rf_1 <- calculate_classification_metrics(conf_matrix=conf_matrix)
```



```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# First time

# Retrieve just the confusion matrix by class
conf_matrix_class_rf_1 <- data.frame(confusion_matrix_rf[["byClass"]])
# Remove several columns
conf_matrix_class_rf_1 <- conf_matrix_class_rf_1[,c(1,2,5,6,7,11)]
```


```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Function to calculate MCC from Sensitivity, Specificity, and counts by class
calculate_MCC <- function(sensitivity, specificity) {
  TP <- sensitivity
  TN <- specificity
  FP <- 1 - TN
  FN <- 1 - TP
  factor <- 1e6
  mcc <- (factor * TP * TN - factor * FP * FN) / sqrt((factor * TP + FP) * (factor * TP + FN) * (factor * TN + FP) * (factor * TN + FN))
  return(mcc)
}
```


```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate MCC for each row in the dataframe and add a new column
conf_matrix_class_rf_1$MCC <- apply(conf_matrix_class_rf_1[, c("Sensitivity", "Specificity")], 1, function(x) calculate_MCC(x[1], x[2]))
```







```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Second time 

# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_rf$table
# Use function
metrics_rf_2 <- calculate_classification_metrics(conf_matrix=conf_matrix)
```

```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Second time

# Retrieve just the confusion matrix by class
conf_matrix_class_rf_2 <- data.frame(confusion_matrix_rf[["byClass"]])
# Remove several columns
conf_matrix_class_rf_2 <- conf_matrix_class_rf_2[,c(1,2,5,6,7,11)]
```

```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate MCC for each row in the dataframe and add a new column
conf_matrix_class_rf_2$MCC <- apply(conf_matrix_class_rf_2[, c("Sensitivity", "Specificity")], 1, function(x) calculate_MCC(x[1], x[2]))
```







```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Third time 

# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_rf$table
# Use function
metrics_rf_3 <- calculate_classification_metrics(conf_matrix=conf_matrix)
```

```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Third time

# Retrieve just the confusion matrix by class
conf_matrix_class_rf_3 <- data.frame(confusion_matrix_rf[["byClass"]])
# Remove several columns
conf_matrix_class_rf_3 <- conf_matrix_class_rf_3[,c(1,2,5,6,7,11)]
```

```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate MCC for each row in the dataframe and add a new column
conf_matrix_class_rf_3$MCC <- apply(conf_matrix_class_rf_3[, c("Sensitivity", "Specificity")], 1, function(x) calculate_MCC(x[1], x[2]))
```







```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Fourth time 

# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_rf$table
# Use function
metrics_rf_4 <- calculate_classification_metrics(conf_matrix=conf_matrix)
```

```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Fourth time

# Retrieve just the confusion matrix by class
conf_matrix_class_rf_4 <- data.frame(confusion_matrix_rf[["byClass"]])
# Remove several columns
conf_matrix_class_rf_4 <- conf_matrix_class_rf_4[,c(1,2,5,6,7,11)]
```


```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate MCC for each row in the dataframe and add a new column
conf_matrix_class_rf_4$MCC <- apply(conf_matrix_class_rf_4[, c("Sensitivity", "Specificity")], 1, function(x) calculate_MCC(x[1], x[2]))
```







```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Fifth time 

# Retrieve just the confusion matrix
conf_matrix <- confusion_matrix_rf$table
# Use function
metrics_rf_5 <- calculate_classification_metrics(conf_matrix=conf_matrix)
```


```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Fifth time

# Retrieve just the confusion matrix by class
conf_matrix_class_rf_5 <- data.frame(confusion_matrix_rf[["byClass"]])
# Remove several columns
conf_matrix_class_rf_5 <- conf_matrix_class_rf_5[,c(1,2,5,6,7,11)]
```


```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate MCC for each row in the dataframe and add a new column
conf_matrix_class_rf_5$MCC <- apply(conf_matrix_class_rf_5[, c("Sensitivity", "Specificity")], 1, function(x) calculate_MCC(x[1], x[2]))
```









```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate mean metrics for overall 

# Store dataframes in list
dataframes_list <- list(metrics_rf_1, metrics_rf_2, metrics_rf_3,
                        metrics_rf_4, metrics_rf_5) 



# Create empty list to store mean of each metrics
averages_list <- list()


# For loop over each row of df (here juste 1 row)
for (i in 1:1) {
  # Create empty list to store mean of each metrics for this classifier
  class_averages <- list()
  
  # For loop over each columns (metrics)
  for (j in 1:7) {
    
    # Calculate mean of this metric for this classifier according to all dataframes (5)
    metric_values <- sapply(dataframes_list, function(df) df[i, j])
    class_average <- mean(metric_values)
    
    # Add mean of this metric to the list that store all means
    class_averages[[j]] <- class_average
  }
  
  # Add the mean list of this classifier to the main mean list (all metrics)
  averages_list[[i]] <- class_averages
}

# Store all means
average_metrics_rf <- do.call(rbind, averages_list)

# Rename columns
colnames(average_metrics_rf) <- c("Mean_Sensitivity", "Mean_Specificity", "Mean_Precision", "Mean_Recall", "Mean_F1", "Mean_Balanced.Accuracy", "Mean_MCC")

# Create data frame
average_metrics_rf <- data.frame(average_metrics_rf)
```




```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Calculate mean metrics by class 

# Store dataframes in list
dataframes_list <- list(conf_matrix_class_rf_1, conf_matrix_class_rf_2,
                        conf_matrix_class_rf_3, conf_matrix_class_rf_4,
                        conf_matrix_class_rf_5) 

# Create empty list to store mean of each metrics
averages_list <- list()

# For loop over each row (class) of df (7 classes)
for (i in 1:7) {
  # Create empty list to store mean of each metrics for this class
  class_averages <- list()
  
  # For loop over each columns (metrics)
  for (j in 1:7) {
    
    # Calculate mean of this metric for this classifier according to all dataframes (5)
    metric_values <- sapply(dataframes_list, function(df) df[i, j])
    class_average <- mean(metric_values)
    
    # Add mean of this metric to the list that store all means
    class_averages[[j]] <- class_average
  }
  
  # Add the mean list of this classifier to the main mean list (all metrics)
  averages_list[[i]] <- class_averages
}

# Store all means
average_metrics_rf_class <- do.call(rbind, averages_list)

# Rename columns
colnames(average_metrics_rf_class) <- c("Mean_Sensitivity", "Mean_Specificity", "Mean_Precision", "Mean_Recall", "Mean_F1", "Mean_Balanced.Accuracy", "Mean_MCC")

# Rename rownames
rownames(average_metrics_rf_class) <- 1:7  

# Create data frame
average_metrics_rf_class <- data.frame(average_metrics_rf_class)

```



```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}

# Add some columns 
average_metrics_pamr$Classifier <- "PAMR_Classifier"
average_metrics_pamr_class$Class <- c("Class1_PAMR", "Class2_PAMR", "Class3_PAMR", 
                                      "Class4_PAMR", "Class5_PAMR", "Class6_PAMR", 
                                      "Class7_PAMR")

average_metrics_rf$Classifier <- "RF_Classifier"
average_metrics_rf_class$Class <- c("Class1_RF", "Class2_RF", "Class3_RF", 
                                      "Class4_RF", "Class5_RF", "Class6_RF", 
                                      "Class7_RF")

average_metrics_svm$Classifier <- "SVM_Classifier"
average_metrics_svm_class$Class <- c("Class1_SVM", "Class2_SVM", "Class3_SVM", 
                                      "Class4_SVM", "Class5_SVM", "Class6_SVM", 
                                      "Class7_SVM")
```


```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# Create function to unlist results of all those dataframes 
unlist_all_columns <- function(dataframe) {
  for (col_name in colnames(dataframe)) {
    dataframe[[col_name]] <- unlist(dataframe[[col_name]])
  }
  return(dataframe)
}

# Use function on all data frames
average_metrics_pamr <- unlist_all_columns(average_metrics_pamr)
average_metrics_pamr_class <- unlist_all_columns(average_metrics_pamr_class)

average_metrics_rf <- unlist_all_columns(average_metrics_rf)
average_metrics_rf_class <- unlist_all_columns(average_metrics_rf_class)

average_metrics_svm <- unlist_all_columns(average_metrics_svm)
average_metrics_svm_class <- unlist_all_columns(average_metrics_svm_class)
```



```{r eval=FALSE, message=FALSE, warning=FALSE, include=TRUE}
# If you want to save file you can do the following :
write_xlsx(average_metrics_pamr,"average_metrics_pamr.xlsx")
write_xlsx(average_metrics_pamr_class,"average_metrics_pamr_class.xlsx")

write_xlsx(average_metrics_rf,"average_metrics_rf.xlsx")
write_xlsx(average_metrics_rf_class,"average_metrics_rf_class.xlsx")

write_xlsx(average_metrics_svm,"average_metrics_svm.xlsx")
write_xlsx(average_metrics_svm_class,"average_metrics_svm_class.xlsx")



```







